// Arne Maus' simple expression grammar example, formulated in Antlr.

/** Scanner. */
class SimpleExpLexer extends Lexer;

WS      : (' '
          | '\t'
          | ('\n') { newline(); })+
        {$setType(Token.SKIP);}
    ;  
PLUS    :	"+";
MINUS	:   "-";
NUMBER  : ('0' .. '9')+
        ;

/** Parser. */
class SimpleExpParser extends Parser;

{ 
    public static void main(String args[]) throws Exception {
        final SimpleExpParser parser = 
            new SimpleExpParser(new SimpleExpLexer(System.in));
        parser.exp();
    }
}

exp : NUMBER ((("+" | "-") NUMBER))*
      EOF!
    ;

